  //// Median Filter Processing

float R_CONST = 0.299 ;
float G_CONST = 0.587 ;
float B_CONST = 0.114 ;

class MedFilClass {

  PImage ds_img;

  MedFilClass(PImage _img) {

    ds_img = _img;
  }
  PImage process() {
    int i;
    int j;
    float iw;
    int pos;
    int posd;
    float val;
    float rval, gval, bval ;
    float[] valc = {0, 0, 0, 0, 0, 0, 0, 0, 0};
    float[] valr = {0, 0, 0, 0, 0, 0, 0, 0, 0};
    float[] valg = {0, 0, 0, 0, 0, 0, 0, 0, 0};
    float[] valb = {0, 0, 0, 0, 0, 0, 0, 0, 0};

    PImage filter_img = createImage( ds_img.width, ds_img.height, RGB);
    ds_img.loadPixels();
    for ( int y = 1 ; y < ds_img.height-1 ; y++ ) { 
      for ( int x = 1 ; x < ds_img.width-1 ; x++ ) { 
        // extract R,G,B 
        posd = 0 ;
        for ( j = -1; j <= 1; j++) {
          for ( i = -1; i <= 1; i++) {
            pos = ( y + j ) * ds_img.width + ( x + i) ;
            valr[posd] = red(ds_img.pixels[pos]);
            valg[posd] = green(ds_img.pixels[pos]);
            valb[posd] = blue(ds_img.pixels[pos]);
            valc[posd] = R_CONST * valr[posd] + G_CONST * valg[posd] + B_CONST * valb[posd] ;
            posd++;
          }
        }
        // sort
        for ( i=0 ; i<=4 ; i++ ) {
          for ( j=i+1 ; j<=8 ; j++ ) {
            if ( valc[i] > valc[j] ) {
              iw = valc[i] ;
              valc[i] = valc[j] ;
              valc[j] = iw ;

              iw = valr[i] ;
              valr[i] = valr[j] ;
              valr[j] = iw ;

              iw = valg[i] ;
              valg[i] = valg[j] ;
              valg[j] = iw ;

              iw = valb[i] ;
              valb[i] = valb[j] ;
              valb[j] = iw ;
            }
          }
        }
        rval = valr[4] ;
        gval = valg[4] ;
        bval = valb[4] ;

        filter_img.pixels[ y * ds_img.width + x ] = color(rval, gval, bval);
      }
    }
    filter_img.updatePixels();
    //// Display
    return filter_img;
  }
}

